# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.0'

from Globals import HTML,HTMLFile,MessageDialog
from ImageFile import ImageFile  
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument
from AccessControl import getSecurityManager


from Acquisition import Implicit
import os,stat,string,posixfile
import sys, traceback, tempfile

#from xml.xslt.Processor import Processor
#from gnosis.xml.objectify import XML_Objectify, pyobj_printer

import XMLConvertionTools as killer

manage_add_dict_Form = HTMLFile('dtml/add_dict_form', globals())



def manage_add_dict(self, id='',title='', file='' , REQUEST=None, submit=None):
    """Add a Xindice Item """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_doc_form',)
    #create new object instance
    id=str(id)
    title=str(title)
    ob=XindiceDict(file, __name__=id)
    ob.title=title
    ob.file = file
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'



class XindiceDict(DTMLDocument, Implicit):
    """ Zope Product object."""    

    meta_type = 'Xindice Dict'
    icon = 'misc_/XindiceDict/docicon'     

    manage_opt = HTMLFile('dtml/manage_doc_options', globals())


    _properties=(
{'id':'title', 'type':'string','mode':'w'},
)



    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	index_html
	"""
	data =  self.view_text(self.server,self.collection,self.query)
	dictx = killer.XMLStringToDictionary()
	dict = dictx.parseXML( data )
	return dict 
	
    def dictionnary(self, xpath, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	XML to Dictionnary
	"""
	self.query = xpath 
	data =  self.view_text(self.server,self.collection,self.query)
	dictx = killer.XMLStringToDictionary()
	dict = dictx.parseXML( data )
	return dict


    def manage_edit(self,data,title, SUBMIT='Change',dtpref_cols='50',
                        dtpref_rows='20',REQUEST=None):
        """
        Replaces a Xindice Item contents with Data, Title with Title.  
        """
        
        self.file = data
	self._p_changed =  1
	ret = DTMLDocument.manage_edit(self,data,title,SUBMIT,dtpref_cols,dtpref_rows,REQUEST)
	return ret
#	u=REQUEST['URL1']
#	REQUEST.RESPONSE.redirect(u+'/manage_main')



Globals.default__class_init__(XindiceDict)


